#!/bin/bash
#Задаем русскую локаль в системе
#sudo dpkg-reconfigure locales
#Надо перезагрузиться

#Задаем русскую локаль в системе
#sudo dpkg-reconfigure locales
#Надо перезагрузиться


sudo locale-gen ru_RU.UTF-8
sudo localectl set-locale LANG=ru_RU.UTF-8 LC_TIME=ru_RU.UTF-8 LC_COLLATE=ru_RU.UTF-8

#Устанавливаем библиотеку libicu55
wget http://archive.ubuntu.com/ubuntu/pool/main/i/icu/libicu55_55.1-7_amd64.deb
sudo dpkg -i libicu55_55.1-7_amd64.deb

if grep "deb http://apt.postgresql.org/pub/repos/apt/ bionic-pgdg main" /etc/apt/sources.list.d/pgdg.list; then
echo 'Уже есть'
else
echo 'deb http://apt.postgresql.org/pub/repos/apt/ bionic-pgdg main' >> /etc/apt/sources.list.d/pgdg.list
fi

wget --quiet -O - https://www.postgresql.org/media/keys/ACCC4CF8.asc | sudo apt-key add -
sudo apt-get update
sudo apt-get install postgresql-common -y
sudo apt-get install libllvm9 -y

sudo dpkg -i libreadline7_7.0-3_amd64.deb
sudo apt-get install -f -y

#Распаковываем архив с postgreSQL
tar -xvf *amd64_deb*
for i in $(find ./ -depth -type d -name *amd64_deb ! -wholename './'); do # Not recommended, will break on whitespace
    #Устанавливаем posgreSQL
    sudo dpkg -i $i/libpq*.deb
    sudo dpkg -i $i/postgresql-client*.deb
    sudo dpkg -i $i/postgresql-1*.deb
    sudo apt-get install -f -y
    #Удаляем созданный ранее каталог
    sudo rm -R $i
done

#Слежение за сервисом postgresql
#sudo service postgresql start
#sudo service postgresql stop
#service postgresql status

#Зафиксируем пакеты, что бы не обновлялись
sudo apt-mark hold libpq5 postgresql-14 postgresql-client-14

systemctl --type=service | grep postgres

# Пример вывода:
#  postgresql.service                                                                        loaded active exited  PostgreSQL RDBMS                                                           
#  postgresql@14-main.service                                                                loaded active running PostgreSQL Cluster 14-main 

# Останавливаем PostgreSQL
#sudo systemctl stop postgresql

# Удаляем файлы ранее созданного при установке кластера
# Вместо 1c-14 может быть другое название каталога, в зависимости от версии.
#rm -r /var/lib/postgresql/14/main/*

# Инициализируем новый кластер для 1С с нужной локалью (не обязательно, если по умолчанию локаль в системе "ru_RU.UTF-8").
#sudo /lib/postgresql/14/bin/pg-setup initdb --tune=1c --locale=ru_RU.UTF-8

# Запускаем PostgreSQL
#sudo systemctl start postgresql

#Зададим пароль для пользователя postgres
sudo -u postgres /usr/bin/psql -U postgres -c "alter user postgres with password 'passwordpostgres';"
sudo -u postgres /usr/bin/psql -U postgres -c "CREATE USER sa SUPERUSER PASSWORD 'passwordpostgres';"

#Имеет смысл перенести хранение временной статистики базы данных с жесткого диска в 
#оперативную память (tmpfs ). Это снизит расход ресурса ssd и немного увеличит 
#производительность. Данное действие не костыль и не грязный хак. Подобную рекомендацию 
#можно увидеть в документации для postgres от команды postgresql pro.
sudo mkdir /var/lib/postgresql/stats_temp
sudo chown postgres:postgres /var/lib/postgresql/stats_temp

#Добавляем tmpfs  диск в /etc/fstab.
sudo sed -i '$ a \\ tmpfs /var/lib/postgresql/stats_temp tmpfs size=512M,uid=postgres,gid=postgres 0 0\n' /etc/fstab

#Пробуем подмонтировать этот диск.
sudo mount /var/lib/postgresql/stats_temp

#Проверяем, что получилось:
#sudo df -h | grep stats_temp
#tmpfs           256M     0  512M   0% /var/lib/pgpro/stats_temp

#Всё в порядке, tmpfs диск подключен. Теперь надо изменить параметр в конфигурационном 
#файле postgresql, который отвечает за настройку каталога для хранения временной 
#статистики. Открываем файл /etc/postgresql/14/main/postgresql.conf и вносим изменение:

#sudo sed -i "$ a \\ stats_temp_directory = '/var/lib/pgpro/stats_temp'\n" /etc/postgresql/14/main/postgresql.conf
sudo sed -i "s#stats_temp_directory = '/var/run/postgresql/14-main.pg_stat_tmp'#stats_temp_directory = '/var/lib/postgresql/stats_temp'#" /etc/postgresql/14/main/postgresql.conf

#stats_temp_directory = '/var/lib/pgpro/stats_temp'

sudo sed -i "$ a \\host    all             all             0.0.0.0/0               password\n" /etc/postgresql/14/main/pg_hba.conf

sudo sed -i "$ a \\listen_addresses = '*'\n" /etc/postgresql/14/main/postgresql.conf


#Перезапускаем службу postgrespro-1c-14 для того, чтобы применить изменение.
sudo systemctl restart postgresql


